// -----------------------------------------------------------------------------
// gulp
var gulp = require('gulp');
var plugins = require('gulp-load-plugins')();

var tasks = [
  'html',
  'javascript',
  'sass',
];

var path = {
  html: {
    src : 'src/html/*.html',
    dest: 'dist/'
  },
  javascript: {
    src : 'src/javascript/*.js',
    dest: 'dist/'
  },
  sass: {
    src : 'src/stylesheet/*.{sass,scss}',
    dest: 'dist/'
  },
  watch: {
    html      : 'src/html/**/*',
    javascript: 'src/javascript/**/*',
    sass      : 'src/stylesheet/**/*',
  }
};

var watch = args('--watch');
var production = args('--production');

if ( watch ) tasks.push('watch');

function args( key ) {
  var index = process.argv.indexOf(key);
  var next = process.argv[index + 1];
  return (index < 0) ? false : (!next || next[0] === "-") ? true : next;
}
// -----------------------------------------------------------------------------


// -----------------------------------------------------------------------------
// default
gulp.task('default', tasks);

// tasks
for ( var i = 0; i < tasks.length; i++ ) {
  var key = tasks[i];
  var opt = {
    gulp      : gulp,
    plugins   : plugins,
    path      : path[key],
    production: production,
    tasks     : tasks
  };
  gulp.task(key, require('./gulp/' + key)(opt));
}
// -----------------------------------------------------------------------------